## mars.tools
Class BHTSimGUI

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  javax.swing.JPanel
                      mars.tools.BHTSimGUI

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable, Accessible

    public class BHTSimGUI

extends JPanel

Represents the GUI of the BHT Simulator Tool.

The GUI consists of mainly four parts:

- A configuration panel to select the number of entries and the history size
- A information panel that displays the most recent branch instruction including its address and BHT index
- A table representing the BHT with all entries and their internal state and statistics
- A log panel that summarizes the predictions in a textual form

Author:
  ingo.kofler@itec.uni-klu.ac.at
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class javax.swing.JPanel
`JPanel.AccessibleJPanel`

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary
`static String` `BHT_DO_NOT_TAKE_BRANCH` constant for the String representing "do not take the branch"
`static String` `BHT_TAKE_BRANCH` constant for the String representing "take the branch"
`static Color` `COLOR_PREDICTION_CORRECT` constant for the color to signal a correct prediction
`static Color` `COLOR_PREDICTION_INCORRECT` constant for the color to signal a misprediction
`static Color` `COLOR_PREPREDICTION` constant for the color that highlights the current BHT entry

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`BHTSimGUI()` Creates the GUI components of the BHT Simulator The GUI is a subclass of JPanel which is integrated in the GUI of the MARS tool

Method Summary
`JComboBox` `getCbBHTentries()` Returns the combo box for selecting the number of BHT entries.
`JComboBox` `getCbBHThistory()` Returns the combo box for selecting the size of the BHT history.
`JComboBox` `getCbBHTinitVal()` Returns the combo box for selecting the initial value of the BHT
`JTable` `getTabBHT()` Returns the table representing the BHT.
`JTextArea` `getTaLog()` Returns the text area for log purposes.
`JTextField` `getTfAddress()` Returns the text field for displaying the address of the most recent branch instruction
`JTextField` `getTfIndex()` Returns the text field for displaying the corresponding index into the BHT
`JTextField` `getTfInstruction()` Returns the text field for displaying the most recent branch instruction

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### COLOR_PREPREDICTION

    public static final Color COLOR_PREPREDICTION

  constant for the color that highlights the current BHT entry

### COLOR_PREDICTION_CORRECT

    public static final Color COLOR_PREDICTION_CORRECT

  constant for the color to signal a correct prediction

### COLOR_PREDICTION_INCORRECT

    public static final Color COLOR_PREDICTION_INCORRECT

  constant for the color to signal a misprediction

### BHT_TAKE_BRANCH

    public static final String BHT_TAKE_BRANCH

  constant for the String representing "take the branch"

  See Also:
    Constant Field Values

### BHT_DO_NOT_TAKE_BRANCH

    public static final String BHT_DO_NOT_TAKE_BRANCH

  constant for the String representing "do not take the branch"

  See Also:
    Constant Field Values

Constructor Detail

### BHTSimGUI

    public BHTSimGUI()

  Creates the GUI components of the BHT Simulator The GUI is a subclass of JPanel which is integrated in the GUI of the MARS tool

Method Detail

### getCbBHTentries

    public JComboBox getCbBHTentries()

  Returns the combo box for selecting the number of BHT entries.

  Returns:
    the reference to the combo box

### getCbBHThistory

    public JComboBox getCbBHThistory()

  Returns the combo box for selecting the size of the BHT history.

  Returns:
    the reference to the combo box

### getCbBHTinitVal

    public JComboBox getCbBHTinitVal()

  Returns the combo box for selecting the initial value of the BHT

  Returns:
    the reference to the combo box

### getTabBHT

    public JTable getTabBHT()

  Returns the table representing the BHT.

  Returns:
    the reference to the table

### getTaLog

    public JTextArea getTaLog()

  Returns the text area for log purposes.

  Returns:
    the reference to the text area

### getTfInstruction

    public JTextField getTfInstruction()

  Returns the text field for displaying the most recent branch instruction

  Returns:
    the reference to the text field

### getTfAddress

    public JTextField getTfAddress()

  Returns the text field for displaying the address of the most recent branch instruction

  Returns:
    the reference to the text field

### getTfIndex

    public JTextField getTfIndex()

  Returns the text field for displaying the corresponding index into the BHT

  Returns:
    the reference to the text field